"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./style/main.css");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function Slider(props) {
  const {
    infinity = false,
    height = '100%',
    borderRadius = 0,
    previousButton,
    nextButton
  } = props;
  let currentSlide = 1;
  (0, _react.useEffect)(() => {
    const root = document.documentElement;
    root.style.setProperty('--main-height-slider', height);
    root.style.setProperty('--border-radius-slide', borderRadius);
    const slide = document.getElementById('main_slider').children[1];
    hideAll(slide.childElementCount, 'main_slider');
    if (slide.children) {
      slide.children[0].className = 'active slide';
    }
    if (slide.children[1]) {
      slide.children[1].className = 'next_slide slide';
    }
  }, []);
  function hideAll(count) {
    for (let i = 1; i <= count; i += 1) {
      const slide = document.getElementById('main_slider').children[1].children[i - 1];
      slide.className = 'hide slide';
    }
  }
  function show(count, direction) {
    hideAll(count);
    const slide = document.getElementById('main_slider').children[1];
    const currSlide = slide.children[currentSlide - 2];
    if (currentSlide == 1 && direction == 'next') {
      // when come to last child, after scroll comeback to first child
      const last = slide.children[count - 1];
      last.className = 'prev slide';
    }
    if (currentSlide == count) {
      const first = slide.children[0];
      first.className = 'next_slide slide';
    }
    if (currSlide && direction == 'next') {
      currSlide.className = 'prev slide';
    }
    if (slide.children[currentSlide - 1].nextSibling != null) {
      slide.children[currentSlide - 1].nextSibling.className = 'next_slide slide';
    }
    if (direction == 'next') {
      slide.children[currentSlide - 1].className = 'active slide';
    } else {
      slide.children[currentSlide - 1].className = 'active_prev slide';
    }
  }
  function prevAction(count) {
    if (currentSlide <= 1 && infinity != 'false' && infinity != false) {
      currentSlide = count;
    } else if (currentSlide != 1) {
      // check if infiniti =flase
      currentSlide -= 1;
    }
    show(count, 'prev');
  }
  function nextAction(count) {
    if (currentSlide >= count && infinity != 'false' && infinity != false) {
      currentSlide = 1;
    } else if (count != currentSlide) {
      // check if infiniti = flase
      currentSlide += 1;
    }
    show(count, 'next');
  }
  function debounce(func, timeout = 50) {
    let timer;
    return (...args) => {
      clearTimeout(timer);
      timer = setTimeout(() => {
        func.apply(this, args);
      }, timeout);
    };
  }
  const wheelForMouse = debounce(e => {
    const count = document.getElementById('main_slider').children[1].childElementCount;
    if (e.deltaY < 0) {
      prevAction(count);
    } else {
      nextAction(count);
    }
  });
  function wheel(e) {
    e.persist();
    wheelForMouse(e);
  }
  let mouseDown = null;
  let mouseUp = null;
  function leftRightClick(e, type) {
    const count = document.getElementById('main_slider').children[1].childElementCount;
    if (type == 'mousedown') {
      mouseDown = e.clientY;
      mouseUp = 0;
    }
    if (type == 'mouseup') {
      mouseUp = e.clientY;
    }
    if (mouseDown && mouseUp) {
      if (mouseDown > mouseUp) {
        prevAction(count);
      } else if (mouseDown < mouseUp) {
        nextAction(count);
      }
    }
  }
  function clickOnArrows(action) {
    const count = document.getElementById('main_slider').children[1].childElementCount;
    action(count, 'main_slider');
  }
  return /*#__PURE__*/_react.default.createElement("section", {
    className: "card_picker"
  }, /*#__PURE__*/_react.default.createElement("div", {
    id: "main_slider",
    className: "slider_card_picker",
    onWheel: e => wheel(e),
    onMouseDown: e => leftRightClick(e, e.type),
    onMouseUp: e => leftRightClick(e, e.type)
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "prev_btn",
    onClick: () => clickOnArrows(prevAction)
  }, previousButton ? /*#__PURE__*/_react.default.createElement("div", {
    dangerouslySetInnerHTML: {
      __html: previousButton
    }
  }) : /*#__PURE__*/_react.default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 24 24",
    width: "50",
    height: "50"
  }, /*#__PURE__*/_react.default.createElement("path", {
    fill: "none",
    d: "M0 0h24v24H0z"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M12 13.172l4.95-4.95 1.414 1.414L12 16 5.636 9.636 7.05 8.222z"
  }))), /*#__PURE__*/_react.default.createElement("div", null, props.children), /*#__PURE__*/_react.default.createElement("button", {
    className: "next_btn",
    onClick: () => clickOnArrows(nextAction)
  }, nextButton ? /*#__PURE__*/_react.default.createElement("div", {
    dangerouslySetInnerHTML: {
      __html: nextButton
    }
  }) : /*#__PURE__*/_react.default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 24 24",
    width: "50",
    height: "50"
  }, /*#__PURE__*/_react.default.createElement("path", {
    fill: "none",
    d: "M0 0h24v24H0z"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M12 13.172l4.95-4.95 1.414 1.414L12 16 5.636 9.636 7.05 8.222z"
  })))));
}
var _default = Slider;
exports.default = _default;